Unary · Groups
Lists role assignments for a group or resource.
Use this method to:
- View all role assignments for a group
- Audit resource access
- Check which groups have access to resources
Examples
-
List role assignments for a group:
Shows all role assignments for a specific group.
filter: groupId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" pagination: pageSize: 20 -
List role assignments by resource type:
Shows all role assignments for runners.
filter: resourceTypes: - RESOURCE_TYPE_RUNNER pagination: pageSize: 20
Authorization
All organization members can view role assignments (transparency model).Endpoint
POST /api/gitpod.v1.GroupService/ListRoleAssignments
https://app.ona.com with that domain.
Request example
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>
curl --request POST \
--url "$ONA_HOST/api/gitpod.v1.GroupService/ListRoleAssignments" \
--header "Authorization: Bearer $ONA_API_KEY" \
--header "Content-Type: application/json" \
--data '{
"pagination": {
"pageSize": 1
}
}'
import gitpod.v1.group_pb2 as group_pb2
import gitpod.v1.pagination_pb2 as pagination_pb2
from ona_sdk import create_client_from_env
ona = create_client_from_env()
request = group_pb2.ListRoleAssignmentsRequest(
pagination=pagination_pb2.PaginationRequest(
page_size=1,
),
)
response = ona.services.group.list_role_assignments(request)
print(response)
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { ListRoleAssignmentsRequestSchema } from "@gitpod/sdk/gitpod/v1/group_pb";
async function main() {
const ona = createClientFromEnv();
const request = create(ListRoleAssignmentsRequestSchema, {
pagination: {
pageSize: 1,
},
});
const response = await ona.services.group.listRoleAssignments(request);
console.log(response);
}
main().catch(console.error);
package main
import (
"context"
"fmt"
"log"
"connectrpc.com/connect"
"github.com/gitpod-io/gitpod-sdk-go/sdk"
gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)
func main() {
ona, err := sdk.NewFromEnv()
if err != nil {
log.Fatal(err)
}
request := connect.NewRequest(&gitpodpb.ListRoleAssignmentsRequest{
Pagination: &gitpodpb.PaginationRequest{
PageSize: 1,
},
})
response, err := ona.Services.Group.ListRoleAssignments(context.Background(), request)
if err != nil {
log.Fatal(err)
}
fmt.Println(response.Msg)
}
{
"pagination": {
"pageSize": 1
}
}
Request
gitpod.v1.ListRoleAssignmentsRequest
ListRoleAssignments messages
| Field | Type | Required | Description |
|---|---|---|---|
pagination | PaginationRequest | No | Pagination parameters |
filter | Filter | No | Filter parameters |
Response
gitpod.v1.ListRoleAssignmentsResponse
| Field | Type | Required | Description |
|---|---|---|---|
pagination | PaginationResponse | No | |
assignments | array of RoleAssignment | No |
Related types
Filter
Filter
gitpod.v1.ListRoleAssignmentsRequest.Filter| Field | Type | Required | Description |
|---|---|---|---|
resourceTypes | array of ResourceType | No | resource_types filters the response to only role assignments for these resource types |
resourceRoles | array of ResourceRole | No | resource_roles filters the response to only role assignments with these specific roles |
groupId | string | No | group_id filters the response to only role assignments for this specific group Empty string is allowed and means no filtering by group |
userId | string | No | user_id filters the response to only role assignments for groups that this user is a member of Empty string is allowed and means no filtering by user |
resourceId | string | No | Filters by a single resource. Non-admin callers with :grant permission on the resource can see role assignments from groups they don’t belong to. Mutually exclusive with resource_ids. |
resourceIds | array of string | No | Filters by multiple resources in a single request. Non-admin callers with :grant permission on a resource can see all role assignments for that resource, even from groups they don’t belong to. The :grant check is applied per-resource within the batch. Mutually exclusive with resource_id. Constraints: repeated.items.string.uuid=true, repeated.max_items=25. |
PaginationRequest
PaginationRequest
gitpod.v1.PaginationRequest| Field | Type | Required | Description |
|---|---|---|---|
pageSize | integer | No | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: int32.gte=0, int32.lte=100. |
token | string | No | Token for the next set of results that was returned as next_token of a PaginationResponse |
PaginationResponse
PaginationResponse
gitpod.v1.PaginationResponse| Field | Type | Required | Description |
|---|---|---|---|
nextToken | string | No | Token passed for retrieving the next set of results. Empty if there are no more results |
RoleAssignment
RoleAssignment
RoleAssignment represents a role assigned to a group on a specific resource
gitpod.v1.RoleAssignment| Field | Type | Required | Description |
|---|---|---|---|
id | string | No | Unique identifier for the role assignment Constraints: string.uuid=true. |
groupId | string | No | Group identifier Constraints: string.uuid=true. |
organizationId | string | No | Organization identifier Constraints: string.uuid=true. |
resourceId | string | No | Resource identifier Constraints: string.uuid=true. |
resourceType | ResourceType | No | Type of resource (runner, project, environment, etc.) |
resourceRole | ResourceRole | No | Role assigned to the group on this resource |
derivedFromOrgRole | ResourceRole | No | The org-level role that created this assignment, if any. RESOURCE_ROLE_UNSPECIFIED means this is a direct share (manually created). Non-zero (e.g., ORG_PROJECTS_ADMIN, ORG_RUNNERS_ADMIN) means this assignment was derived from an org-level role. |
ResourceRole
ResourceRole
ResourceRole represents roles that can be assigned to groups on resources
These map directly to the roles defined in backend/db/rule/rbac/role/role.go
| Value | Number | Description |
|---|---|---|
RESOURCE_ROLE_UNSPECIFIED | 0 | |
RESOURCE_ROLE_ORG_ADMIN | 1 | Organization roles |
RESOURCE_ROLE_ORG_MEMBER | 2 | |
RESOURCE_ROLE_ORG_RUNNERS_ADMIN | 50 | |
RESOURCE_ROLE_ORG_PROJECTS_ADMIN | 51 | |
RESOURCE_ROLE_ORG_AUTOMATIONS_ADMIN | 52 | |
RESOURCE_ROLE_ORG_GROUPS_ADMIN | 53 | |
RESOURCE_ROLE_ORG_ENVIRONMENTS_READER | 66 | |
RESOURCE_ROLE_ORG_AUDIT_LOG_READER | 64 | |
RESOURCE_ROLE_ORG_BILLING_VIEWER | 67 | |
RESOURCE_ROLE_ORG_INSIGHTS_VIEWER | 68 | |
RESOURCE_ROLE_ORG_SECURITY_ADMIN | 69 | |
RESOURCE_ROLE_ORG_DEFENCE_FACTORY_ADMIN | 72 | |
RESOURCE_ROLE_GROUP_ADMIN | 3 | Group roles |
RESOURCE_ROLE_GROUP_VIEWER | 4 | |
RESOURCE_ROLE_USER_IDENTITY | 5 | User roles |
RESOURCE_ROLE_USER_VIEWER | 6 | |
RESOURCE_ROLE_USER_ADMIN | 7 | |
RESOURCE_ROLE_ENVIRONMENT_IDENTITY | 8 | Environment roles |
RESOURCE_ROLE_ENVIRONMENT_ADMIN | 9 | |
RESOURCE_ROLE_ENVIRONMENT_USER | 10 | |
RESOURCE_ROLE_ENVIRONMENT_VIEWER | 11 | |
RESOURCE_ROLE_ENVIRONMENT_RUNNER | 12 | |
RESOURCE_ROLE_RUNNER_IDENTITY | 13 | Runner roles |
RESOURCE_ROLE_RUNNER_ADMIN | 14 | |
RESOURCE_ROLE_RUNNER_LOCAL_ADMIN | 15 | |
RESOURCE_ROLE_RUNNER_MANAGED_ADMIN | 16 | |
RESOURCE_ROLE_RUNNER_USER | 17 | |
RESOURCE_ROLE_RUNNER_CONFIGURATION_READER | 18 | |
RESOURCE_ROLE_HOST_AUTHENTICATION_TOKEN_ADMIN | 19 | Host authentication token roles |
RESOURCE_ROLE_HOST_AUTHENTICATION_TOKEN_UPDATER | 20 | |
RESOURCE_ROLE_PROJECT_ADMIN | 21 | Project roles |
RESOURCE_ROLE_PROJECT_USER | 22 | |
RESOURCE_ROLE_PROJECT_EDITOR | 23 | |
RESOURCE_ROLE_ENVIRONMENT_SERVICE_ADMIN | 24 | Environment service roles |
RESOURCE_ROLE_ENVIRONMENT_SERVICE_VIEWER | 25 | |
RESOURCE_ROLE_ENVIRONMENT_SERVICE_USER | 26 | |
RESOURCE_ROLE_ENVIRONMENT_SERVICE_ENV | 27 | |
RESOURCE_ROLE_ENVIRONMENT_TASK_ADMIN | 28 | Environment task roles |
RESOURCE_ROLE_ENVIRONMENT_TASK_VIEWER | 29 | |
RESOURCE_ROLE_ENVIRONMENT_TASK_USER | 30 | |
RESOURCE_ROLE_ENVIRONMENT_TASK_ENV | 31 | |
RESOURCE_ROLE_SERVICE_ACCOUNT_IDENTITY | 32 | Service account roles |
RESOURCE_ROLE_SERVICE_ACCOUNT_ADMIN | 33 | |
RESOURCE_ROLE_AGENT_EXECUTION_USER | 35 | |
RESOURCE_ROLE_AGENT_EXECUTION_ADMIN | 36 | |
RESOURCE_ROLE_AGENT_EXECUTION_RUNNER | 37 | |
RESOURCE_ROLE_AGENT_EXECUTION_OUTPUTS_REPORTER | 46 | |
RESOURCE_ROLE_AGENT_EXECUTION_VIEWER | 65 | |
RESOURCE_ROLE_AGENT_ADMIN | 38 | Agent roles |
RESOURCE_ROLE_AGENT_VIEWER | 39 | |
RESOURCE_ROLE_AGENT_EXECUTOR | 40 | |
RESOURCE_ROLE_WORKFLOW_ADMIN | 41 | Workflow roles |
RESOURCE_ROLE_WORKFLOW_USER | 42 | |
RESOURCE_ROLE_WORKFLOW_VIEWER | 43 | |
RESOURCE_ROLE_WORKFLOW_EXECUTOR | 47 | |
RESOURCE_ROLE_SNAPSHOT_ADMIN | 44 | Snapshot roles |
RESOURCE_ROLE_SNAPSHOT_RUNNER | 45 | |
RESOURCE_ROLE_WEBHOOK_ADMIN | 48 | Webhook roles |
RESOURCE_ROLE_WEBHOOK_VIEWER | 49 | |
RESOURCE_ROLE_WARMPOOL_RUNNER | 54 | |
RESOURCE_ROLE_WARMPOOL_ADMIN | 55 | |
RESOURCE_ROLE_WARMPOOL_VIEWER | 56 | |
RESOURCE_ROLE_SESSION_ADMIN | 60 | Session roles |
RESOURCE_ROLE_SESSION_USER | 61 | |
RESOURCE_ROLE_TEAM_ADMIN | 62 | |
RESOURCE_ROLE_TEAM_VIEWER | 63 | |
RESOURCE_ROLE_SECURITY_POLICY_ADMIN | 70 | |
RESOURCE_ROLE_SECURITY_POLICY_VIEWER | 71 |
ResourceType
ResourceType
| Value | Number | Description |
|---|---|---|
RESOURCE_TYPE_UNSPECIFIED | 0 | |
RESOURCE_TYPE_ENVIRONMENT | 1 | |
RESOURCE_TYPE_RUNNER | 2 | |
RESOURCE_TYPE_PROJECT | 3 | |
RESOURCE_TYPE_TASK | 4 | |
RESOURCE_TYPE_TASK_EXECUTION | 5 | |
RESOURCE_TYPE_SERVICE | 6 | |
RESOURCE_TYPE_ORGANIZATION | 7 | |
RESOURCE_TYPE_USER | 8 | |
RESOURCE_TYPE_ENVIRONMENT_CLASS | 9 | |
RESOURCE_TYPE_RUNNER_SCM_INTEGRATION | 10 | |
RESOURCE_TYPE_HOST_AUTHENTICATION_TOKEN | 11 | |
RESOURCE_TYPE_GROUP | 12 | |
RESOURCE_TYPE_PERSONAL_ACCESS_TOKEN | 13 | |
RESOURCE_TYPE_USER_PREFERENCE | 14 | |
RESOURCE_TYPE_SERVICE_ACCOUNT | 15 | |
RESOURCE_TYPE_SECRET | 16 | |
RESOURCE_TYPE_SSO_CONFIG | 17 | |
RESOURCE_TYPE_DOMAIN_VERIFICATION | 18 | |
RESOURCE_TYPE_AGENT_EXECUTION | 19 | |
RESOURCE_TYPE_RUNNER_LLM_INTEGRATION | 20 | |
RESOURCE_TYPE_AGENT | 21 | |
RESOURCE_TYPE_ENVIRONMENT_SESSION | 22 | |
RESOURCE_TYPE_USER_SECRET | 23 | |
RESOURCE_TYPE_ORGANIZATION_POLICY | 24 | |
RESOURCE_TYPE_ORGANIZATION_SECRET | 25 | |
RESOURCE_TYPE_PROJECT_ENVIRONMENT_CLASS | 26 | |
RESOURCE_TYPE_BILLING | 27 | |
RESOURCE_TYPE_PROMPT | 28 | |
RESOURCE_TYPE_COUPON | 29 | |
RESOURCE_TYPE_COUPON_REDEMPTION | 30 | |
RESOURCE_TYPE_ACCOUNT | 31 | |
RESOURCE_TYPE_INTEGRATION | 32 | |
RESOURCE_TYPE_WORKFLOW | 33 | |
RESOURCE_TYPE_WORKFLOW_EXECUTION | 34 | |
RESOURCE_TYPE_WORKFLOW_EXECUTION_ACTION | 35 | |
RESOURCE_TYPE_SNAPSHOT | 36 | |
RESOURCE_TYPE_PREBUILD | 37 | |
RESOURCE_TYPE_ORGANIZATION_LLM_INTEGRATION | 38 | |
RESOURCE_TYPE_CUSTOM_DOMAIN | 39 | |
RESOURCE_TYPE_ROLE_ASSIGNMENT_CHANGED | 40 | |
RESOURCE_TYPE_GROUP_MEMBERSHIP_CHANGED | 41 | |
RESOURCE_TYPE_WEBHOOK | 42 | |
RESOURCE_TYPE_SCIM_CONFIGURATION | 43 | |
RESOURCE_TYPE_SERVICE_ACCOUNT_SECRET | 44 | |
RESOURCE_TYPE_ANNOUNCEMENT_BANNER | 45 | |
RESOURCE_TYPE_SERVICE_ACCOUNT_TOKEN | 46 | |
RESOURCE_TYPE_ROLE_ASSIGNMENT | 47 | |
RESOURCE_TYPE_WARM_POOL | 48 | |
RESOURCE_TYPE_NOTIFICATION | 49 | |
RESOURCE_TYPE_SECURITY_POLICY | 50 |